var autoShutdown = {
	//Global variables
	isActive: false,						//Does user ativate shutdown functionality
	numberOfActiveDownloads: 0,				//Number of active downloads of FF download manager
	numberOfActiveDownloadsOfDTA: 0,		//Number of active downloads of DownThemAll
	isIdleListenerInstalled: false,			//Is IDLE Listener installed
	isShutdownListenerInstalled: false, 	//Is Shutdown Listener installed
	isDTASafe: true,						//Do not rely on what dTa says are "running" downloads. Finishing downloads are not counted against running downloads

	//Components
	idleService: Components.classes["@mozilla.org/widget/idleservice;1"]
			.getService(Components.interfaces.nsIIdleService),
	prefs: Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefService).getBranch("InBasic.ShutDown."),
	timer: Components.classes["@mozilla.org/timer;1"]
			.createInstance(Components.interfaces.nsITimer),
	sound: Components.classes["@mozilla.org/sound;1"] 
						.createInstance(Components.interfaces.nsISound),		
			
	/*Play a wave track after mSec*/
	playSound: function (path, mSec) {
		//From: http://bugs.code.downthemall.net/trac/changeset/1201
		var xulRuntime = Components.classes["@mozilla.org/xre/app-info;1"]
						.getService(Components.interfaces.nsIXULRuntime);
		if (/linux|sun|bsd|aix|hp|dragonfly|irix/i.test(xulRuntime.OS) && /64/.test(xulRuntime.XPCOMABI)) 
			return;	//*nix 64 - freeze problems


		var uri = Components.classes['@mozilla.org/network/standard-url;1'] 
						.createInstance(Components.interfaces.nsIURI); 
		uri.spec = path;
		var vPlaySound = { notify: function(){autoShutdown.sound.play(uri);} }; 
		
		
		var timer2 = Components.classes["@mozilla.org/timer;1"]
			.createInstance(Components.interfaces.nsITimer);
		
		timer2.initWithCallback(vPlaySound, mSec , Components.interfaces.nsITimer.TYPE_ONE_SHOT);		
	},	
	/*Open counter window*/
	openCounter: function (type) {	
		// set command type which should be executed
		var array = Components.classes["@mozilla.org/array;1"]
							  .createInstance(Components.interfaces.nsIMutableArray);
		var variant = Components.classes["@mozilla.org/variant;1"]
								.createInstance(Components.interfaces.nsIWritableVariant);
		variant.setFromVariant(type);  //command type for idle
		array.appendElement(variant, false);

		var winComponent = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
			.getService(Components.interfaces.nsIWindowWatcher);
		winComponent.openWindow(null, "chrome://inbshutdown/content/Shutdown.xul",
								"Shutdown :: InBasic", "chrome,centerscreen, resizable=no", array);	
	},
	/*Rewrite statusbar download counter*/
	setDownloadCount: function () {
		//Try to locate DTA
		try {
			var isDTAInstalled = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService).getBranch("extensions.dta.").getCharPref("filter");
			isDTAInstalled = isDTAInstalled && this.prefs.getBoolPref("supportDTA");
		} catch (e) {
			var isDTAInstalled = null;
		}
	
		var dlmgr = Components.classes['@mozilla.org/download-manager;1']
			.getService(Components.interfaces.nsIDownloadManager);
		var wm =Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browserEnumerator = wm.getEnumerator("navigator:browser");
		while( browserEnumerator.hasMoreElements() ) {   //maybe more than 1 window is open!
			var dc = browserEnumerator.getNext().document;
			dc.getElementById('Sd.Status.Label').value = 
				isDTAInstalled ? "FDM: " + dlmgr.activeDownloadCount + " DTA: " + this.numberOfActiveDownloadsOfDTA : dlmgr.activeDownloadCount;
			dc.getElementById('Sd.Status.Label').hidden = 
				this.prefs.getBoolPref('StatusCounterHide') || 
				((dlmgr.activeDownloadCount == 0) && (this.numberOfActiveDownloadsOfDTA == 0));
		}
		return dlmgr.activeDownloadCount;
	},	
	
	idleObserver: {
		observe: function(subject, topic, data) {
			var dlmgr = Components.classes['@mozilla.org/download-manager;1']
				.getService(Components.interfaces.nsIDownloadManager);
		
			if (dlmgr.activeDownloadCount == 0 && topic == "idle" )
				autoShutdown.openCounter(1); //command type for idle
		}
	},
	shutdownListener: {
		onProgressChange: function(webProgress,request,curSelfProgres,maxSelfProgress,curTotalProgres,maxTotalProgress,download){
		}, 
		onSecurityChange: function(webProgress,request,state,download){
		}, 
		onStateChange: function(webProgress,request,stateFlags,status,download){
		},
		onDownloadStateChange : function(aState,aDownload){
			var dlmgr = Components.classes['@mozilla.org/download-manager;1']
				.getService(Components.interfaces.nsIDownloadManager);
			//update download counter
			this.numberOfActiveDownloads = autoShutdown.setDownloadCount();
			switch(aDownload.state) {
				case Components.interfaces.nsIDownloadManager.DOWNLOAD_FINISHED:
				case Components.interfaces.nsIDownloadManager.DOWNLOAD_FAILED:
				case Components.interfaces.nsIDownloadManager.DOWNLOAD_CANCELED:	
				case "DTA":
					//play sound after each download; only for FF download manager
					if (autoShutdown.prefs.getCharPref("sndMode") == '0' && aState != "DTA" ) {
						autoShutdown.playSound("chrome://inbshutdown/skin/sounds/done.wav", 1000);
					}
					//Play sound if all finished; only for FF download manager
					if (autoShutdown.prefs.getCharPref("sndMode") == '1' && dlmgr.activeDownloadCount == 0 && aState != "DTA")
						autoShutdown.playSound("chrome://inbshutdown/skin/sounds/done.wav", 1000);
					//show shutdown window if needed (Support for DownThemAll)					
					if (autoShutdown.isActive && (dlmgr.activeDownloadCount == 0) && ((autoShutdown.prefs.getBoolPref("supportDTA") && autoShutdown.isDTASafe) || !autoShutdown.prefs.getBoolPref("supportDTA"))  ) {
						//Open Window
						var callback = {
							notify: function(timer) {
								if(dlmgr.activeDownloadCount==0)					
									autoShutdown.openCounter(0)	; //command type for shutdown
							}
						};				  
						autoShutdown.timer.initWithCallback(callback, 1000 * autoShutdown.prefs.getCharPref("TimeBeforeStart"), Components.interfaces.nsITimer.TYPE_ONE_SHOT);
					}			
			}
		}
	}		
}

function auto_shutdown_component() {
    this.wrappedJSObject = this;
}

auto_shutdown_component.prototype = {
	classID: Components.ID("{CED48986-935D-11DC-866B-6A9056D89593}"), 
	contractID: "@InBasic.org/AutoShutdown/component;1",
	classDescription: "InBasic Auto Shutdown Component",

	QueryInterface: function(aIID) {
		if(!aIID.equals(CI.nsISupports) && !aIID.equals(CI.nsIObserver) && !aIID.equals(CI.nsISupportsWeakReference)) // you can claim you implement more interfaces here
			throw CR.NS_ERROR_NO_INTERFACE;
		return this;
	},
  
	observe: function(aSubject, aTopic, aData) {
		switch(aTopic) {
		case "xpcom-startup":
			autoShutdown.isActive = false; //initializing Auto-Shutdown extension
			autoShutdown.numberOfActiveDownloads = 0;
			break;
		default:
			throw Components.Exception("Unknown topic: " + aTopic);
		}
	},
  
	onLoad: function() {
		if( !autoShutdown.isShutdownListenerInstalled ) {     
			var dlmgr = Components.classes['@mozilla.org/download-manager;1']
				.getService(Components.interfaces.nsIDownloadManager);
			dlmgr.addListener(autoShutdown.shutdownListener);
			autoShutdown.isShutdownListenerInstalled = true;
		}
	},
  
	activateIDETest : function(){
		if( autoShutdown.isActive && autoShutdown.prefs.getBoolPref("IDETest") ){
			autoShutdown.idleService.addIdleObserver(autoShutdown.idleObserver, autoShutdown.prefs.getCharPref("IDEDelay")); // per sec
			autoShutdown.isIdleListenerInstalled = true;
		}
	},
  
	deactivateIDE : function(){
		if ( autoShutdown.isIdleListenerInstalled ) {
			autoShutdown.idleService.removeIdleObserver(autoShutdown.idleObserver, autoShutdown.prefs.getCharPref("IDEDelay"));
			autoShutdown.isIdleListenerInstalled = false;
		}
	},
  
	isAutoShutdownActive : function(){
		return autoShutdown.isActive;
	},
  
	setAutoShutdownActive : function(bol){
		autoShutdown.isActive = bol;
	}, 
  
	iNumberOfADownload : function(){
		return autoShutdown.numberOfActiveDownloads;
	},
	/*Fired when DTA changes*/
	setNumberOfDownloadsOfDTA : function (num, isSafe) {	
		if (num != autoShutdown.numberOfActiveDownloadsOfDTA && autoShutdown.prefs.getBoolPref("supportDTA")) {
			autoShutdown.numberOfActiveDownloadsOfDTA = num;
			autoShutdown.isDTASafe = isSafe;
			//Fire listener manually!
			autoShutdown.shutdownListener.onDownloadStateChange("DTA", {state:"DTA"});
		}
	}
};


var objects = [auto_shutdown_component];

const CI = Components.interfaces, CC = Components.classes, CR = Components.results;
const MY_OBSERVER_NAME = "InBasic Autoshutdown - Component Observer";

function FactoryHolder(aObj) {
  this.CID        = aObj.prototype.classID;
  this.contractID = aObj.prototype.contractID;
  this.className  = aObj.prototype.classDescription;
  this.factory = {
    createInstance: function(aOuter, aIID) {
      if(aOuter)
        throw CR.NS_ERROR_NO_AGGREGATION;
      return (new this.constructor).QueryInterface(aIID);
    }
  };
  this.factory.constructor = aObj;
}

var gModule = {
  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType)
  {
    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.registerFactoryLocation(obj.CID, obj.className,
        obj.contractID, aFileSpec, aLocation, aType);
    }

    // this can be deleted if you don't need to init on startup
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    catman.addCategoryEntry("xpcom-startup", MY_OBSERVER_NAME,
      auto_shutdown_component.prototype.contractID, true, true);
    catman.addCategoryEntry("xpcom-shutdown", MY_OBSERVER_NAME,
      auto_shutdown_component.prototype.contractID, true, true);
  },

  unregisterSelf: function(aCompMgr, aFileSpec, aLocation) {
    // this must be deleted if you delete the above code dealing with |catman|
    var catman = CC["@mozilla.org/categorymanager;1"].getService(CI.nsICategoryManager);
    catman.deleteCategoryEntry("xpcom-startup", MY_OBSERVER_NAME, true);
    // end of deleteable code

    aComponentManager.QueryInterface(CI.nsIComponentRegistrar);
    for (var key in this._objects) {
      var obj = this._objects[key];
      aComponentManager.unregisterFactoryLocation(obj.CID, aFileSpec);
    }
  },

  getClassObject: function(aComponentManager, aCID, aIID) {
    if (!aIID.equals(CI.nsIFactory)) throw CR.NS_ERROR_NOT_IMPLEMENTED;

    for (var key in this._objects) {
      if (aCID.equals(this._objects[key].CID))
        return this._objects[key].factory;
    }
   
    throw CR.NS_ERROR_NO_INTERFACE;
  },

  canUnload: function(aComponentManager) {
    return true;
  },

  _objects: {} //FactoryHolder
};

function NSGetModule(compMgr, fileSpec)
{
  for(var i in objects)
    gModule._objects[i] = new FactoryHolder(objects[i]);
  return gModule;
} 
